var __assign = this && this.__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __rest = this && this.__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

import { jsx as _jsx, jsxs as _jsxs } from "react/jsx-runtime";
import * as React from 'react';
import classNames from 'classnames';
import "./style/badge.css";
var prefixCls = 'dmc-badge';

var Badges = function Badges(props) {
  var _a;

  var className = props.className,
      style = props.style,
      count = props.count,
      overflowCount = props.overflowCount,
      showZero = props.showZero,
      dot = props.dot,
      type = props.type,
      offsetFromTopRight = props.offsetFromTopRight,
      badgeStyle = props.badgeStyle,
      children = props.children,
      restProps = __rest(props, ["className", "style", "count", "overflowCount", "showZero", "dot", "type", "offsetFromTopRight", "badgeStyle", "children"]);

  var displayCount = overflowCount === undefined ? count : count > overflowCount ? overflowCount + "+" : count;
  var isZero = displayCount === 0;
  var isHidden = displayCount === null || displayCount === undefined || displayCount === '' || isZero && !showZero;
  var badgeCls = classNames(prefixCls, className, (_a = {}, _a[prefixCls + "-" + type] = type, _a));
  var styleWithOffset = offsetFromTopRight ? __assign({
    right: -parseInt(offsetFromTopRight[0], 10),
    marginTop: offsetFromTopRight[1]
  }, badgeStyle) : badgeStyle;
  return _jsxs("div", __assign({}, restProps, {
    style: style,
    className: badgeCls
  }, {
    children: [children, !isHidden && (isZero && showZero || !isZero && !dot) && _jsx("span", __assign({
      style: styleWithOffset,
      className: prefixCls + "-count"
    }, {
      children: displayCount
    }), void 0), !isHidden && !isZero && dot && _jsx("span", {
      style: styleWithOffset,
      className: prefixCls + "-dot"
    }, void 0)]
  }), void 0);
};

Badges.defaultProps = {
  showZero: false,
  dot: false,
  overflowCount: 99
};
Badges.displayName = 'Badge';
export default Badges;
var BadgesMemo = /*#__PURE__*/React.memo(Badges);
BadgesMemo.displayName = 'BadgeMemo';
export { BadgesMemo };

